<?php

class TemplateApiFieldsetInputType extends TemplateApiInputType {
  public function form($input_definition, $input_values) {
    $form = array();

    $form['fieldset'] = array(
      '#type' => 'fieldset',
      '#title' => $input_definition['label'],
      '#collapsible' => FALSE,
      '#collapsed' => FALSE,
      '#tree' => TRUE,
    );

    foreach ($input_definition['children'] as $key=>$input) {
      $form['fieldset'][$key] = template_api_get_input_type_controller($input['type'])
        ->getForm($input, $input_values['fieldset'][$key]);
    }

    return $form;
  }

  public function getVariable($input_values) {
    $output = array();
    foreach ($input_values['fieldset'] as $key=>$value) {
      foreach ($value as $type=>$data) {
        $output[$key] = $data;
      } 
    }

    return $output;
  }

  public function isEmpty($input_values) {
    return empty($input_values['fieldset']);
  }
}