<?php

class TemplateApiFileInputType extends TemplateApiInputType {
  public function form($input_definition, $input_values) {
    $form = array();

    $form['file_fid'] = array(
      '#type' => 'managed_file',
      '#title' => $input_definition['label'],
      '#default_value' => isset($input_values['file_fid']['fid']) ? $input_values['file_fid']['fid'] : '',
    );

    return $form;
  }

  public function validate($input_definition, $input_values, &$form_state) {
    // @TODO handle deletes
    // we don't know what the old fid is
    if (!empty($input_values['file_fid']['fid'])) {
      // Load the file if it exists
      if ($file = file_load($input_values['file_fid']['fid'])) {
        $file->status =  FILE_STATUS_PERMANENT;

        file_save($file);
        // @TODO something better here?
        file_usage_add($file, 'template_api', 'file_input', 0);
      }
    }
  }


  public function getVariable($input_values) {
    if ($file = file_load($input_values['file_fid']['fid'])) {
      return file_create_url($file->uri);
    }
    else {
      return array();
    }
  }

  public function isEmpty($input_values) {
    if (!isset($input_values['file_fid']['fid'])) {
      return TRUE;
    }

    if ($file = file_load($input_values['file_fid']['fid'])) {
      return FALSE;
    }

    return FALSE;
  }
}