<?php

class TemplateApiVerticalTabsInputType extends TemplateApiInputType {
  public function form($input_definition, $input_values) {
    $form = array();

    $form['vertical_tabs'] = array(
      '#type' => 'vertical_tabs',
      '#title' => $input_definition['label'],
      '#collapsible' => FALSE,
      '#collapsed' => FALSE,
      '#tree' => TRUE,
    );

    foreach ($input_definition['children'] as $key=>$input) {
      $form['vertical_tabs'][$key] = template_api_get_input_type_controller($input['type'])
        ->getForm($input, $input_values['vertical_tabs'][$key]);
    }

    return $form;
  }

  public function getVariable($input_values) {
    $output = array();
    foreach ($input_values['vertical_tabs'] as $key=>$value) {
      if (is_array($value)) {
        foreach ($value as $type=>$data) {
          $controller = template_api_get_input_type_controller($type);
          $output[] = $controller->getVariable($value);
        }
      }
    }

    return $output;
  }

  public function isEmpty($input_values) {
    return empty($input_values['vertical_tabs']);
  }
}